        PAGE ,132
        TITLE 64 Bit Display Routine
.MODEL Small
        .XCREF
        .XLIST
INCLUDE  DEFMS.ASM ; MACROs and MS-DOS definitions from Heath/Zenith software.
        .LIST
        .CREF

UseAAM  EQU     0       ; EQUate to use AAM or DIV.
UseBSR  EQU     1       ; EQUate to choose a BSR jump table or simple search.

.386
.stack
.data
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; - - -  Data area for HNumDisp routine.  - - -
Labels  DB     'Bytes', 'KiB  ', 'MiB  ', 'GiB  ', 'TiB  ', 'PiB  ', 'EiB  '
Hundred DB     100      ; Constant for generating fraction.
Ten     DW     10       ; Constant to display digits
HND_Str DB     '     .        ', 13, 10, '$' ; Change last to $ for DOS, 0 for C

IF UseBSR
; Table of addresses to jump to, based on high bit.
JmpTab  DD     HND_0, HND_1, HND_2, HND_3, HND_4, HND_5, HND_6
ENDIF
; - - -
.code
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Start:  ; Test our routine

        MOV     AX,SEG @DATA    ; Set up DOS segment registers
        MOV     DS,AX
        MOV     ES,AX

        MOV     EDX,0
        MOV     EAX,0A5A5A5A5H
        CALL HNumDisp          ; Do the test.
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR           ; Display the results.

        MOV     EDX,0
        MOV     EAX,0
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR

        MOV     EDX,0
        MOV     EAX,1023
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR

        MOV     EDX,0
        MOV     EAX,1024
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR

        MOV     EDX,0
        MOV     EAX,1536
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR

        MOV     EDX,0FFFFFFFFH
        MOV     EAX,0FFFFFFFFH
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR

        MOV     EDX,0FFFFFFFH
        MOV     EAX,0FFFFFFFFH
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR

        SCALL EXIT      ; MS-DOS Exit Fn 4CH

; - - -  HNumDisp routine.  - - -
; Display a number in terms of 10 bit chunks (bytes, kiloytes, etc.).
; 31 July 2008, first attempt, SRN.
; 3 August 2008, bug fix, SRN.
; 11 August 2008, some code clean-up, SRN.  Simplify ten bit display.
; Change fraction display code from AAM to DIV (optional).  And try
; using the BSR and SHRD instructions.
; 12 August 2008, debug...  The BSR code is using a divide by 10 to
; avoid a large jump table or an extra indirection table.  Code is ugly
; but should be understandable.

; EDX:EAX has the number on input.
; HND_Str has a string on output.
HNumDisp:
        PUSHAD  ; Save all registers as we were asked to make an OS
                ; neutral routine.
        PUSHFD  ; And save state of direction flag?  (Nope)

IF UseBSR       ; Use Bit Scan Reverse to find highest set bit.
        XOR     EBX,EBX ; Zero EBX, BSR only updates if a bit is set.
        BSR     EBX,EDX ; Scan for highest bit set in high word.
        JZ      HND_b1  ; If zero, look in low word.

        ADD     EBX,32  ; EDX is the high word.
        JMP     HND_b2

HND_b1:
        BSR     EBX,EAX ; Scan for highest bit set in low word.

HND_b2: ; BL should now have the bit position.

        MOV     ECX,EDX ; Temp storage of number to be displayed.
        MOV     EBP,EAX

        MOV     EAX,EBX ; Highest bit number ( 0 - 63 )
        XOR     EDX,EDX ; Clear (E)DX, else error.
        DIV     [Ten]   ; ( AL = 0 - 6 )
        MOV     EBX,EAX ; Put back into BL as the rest of the code will
                        ;  process EDX:EAX.
        MOV     EDX,ECX ; Restore EDX:EAX after trashing by divide.
        MOV     EAX,EBP

        JMP     [JmpTab+EBX*4]  ; Go to routine based on 10 bit chunks.

HND_0:  ;  9 - 0 bits - 'Bytes'
        ; No shift needed and no fraction.
        MOV     EBX,0   ; Offset of label in Labels array.
        MOV     EDI,3   ; String offset for ten bit case with no fraction.
        JMP     HND_19  ; Go to process the 10 selected bits.

HND_1:  ; 19 - 10 bits - 'KiB  '
        SHR     EAX,2   ; Shift 20 bits 2 right to get 18 bits.
        MOV     EBX,5
        JMP     HND_18  ; Go to process the 18 selected bits.

HND_2:  ; 29 - 20 bits - 'MiB  '
        SHR     EAX,12  ; shift 12
        MOV     EBX,10
        JMP     HND_18

HND_3:  ; 39 - 30 bits - 'GiB  '
        MOV     CL,22
        SHRD    EAX,EDX,CL      ; OKay, here is where this can be used.
        MOV     EBX,20          ;   This shift spans the two registers and
        JMP     HND_18          ;   saves a rotate loop like below.  But
                                ;   it is limited to a count modulo 32.
HND_4:  ; 49 - 40 bits - 'TiB  '
        MOV     EAX,EDX ; ~Shift 32
        MOV     EBX,20  ; Offset of label
        JMP     HND_18

HND_5:  ; 59 - 50 bits - 'PiB  '
        MOV     EAX,EDX ; ~Shift 32
        SHR     EAX,10  ; further shift to 42
        MOV     EBX,25
        JMP     HND_18

HND_6:  ; 63 - 60 bits - 'EiB  '
; Shift count to get 18 bits to play with.  (We will want 12 bits for the
; first case as we only have 4 bits possible.)

        MOV     EAX,EDX ; ~Shift 32
        SHR     EAX,20  ; further shift to 52
        MOV     EBX,30  ; Offset of label in Labels array.
;       JMP     HND_18

HND_18: ; - - - Convert eighteen bits to a display string.  - - -
ELSE    ; Use a straight forward search to find the highest set bit.

; - - - test 63 - 60 bits - - - 'EiB  '
; Nybble counter     87654321
        TEST    EDX,0F0000000H  ; Test the high four bits.
        JZ      HND_1           ; If none set, go do it again.
        MOV     ECX,52  ; Shift count to get 18 bits to play with.
        MOV     EBX,30  ; Offset of label in Labels array.
        JMP     HND_18  ; Go to process the selected bits.

; - - - test 59 - 50 bits - - - 'PiB  '
HND_1:
        TEST    EDX,00FFC0000H
        JZ      HND_2
        MOV     ECX,42
        MOV     EBX,25
        JMP     HND_18

; - - - test 49 - 40 bits - - - 'TiB  '
HND_2:
        TEST    EDX,00003FF00H
        JZ      HND_3
        MOV     ECX,32
        MOV     EBX,20
        JMP     HND_18

; - - - test 39 - 30 bits - - - 'GiB  '
HND_3:
; Nybble counter     87654321
        TEST    EDX,0000000FFH  ; Lower eight from high DWORD.
        JNZ     HND_3a
        TEST    EAX,0C0000000H  ; Highest two from low DWORD.
        JZ      SHORT HND_4
HND_3a:
        MOV     ECX,22
        MOV     EBX,15
        JMP     HND_18

; - - - test 29 - 20 bits - - - 'MiB  '
HND_4:
        TEST    EAX,03FF00000H
        JZ      HND_5
        MOV     ECX,12
        MOV     EBX,10
        JMP     HND_18

; - - - test 19 - 10 bits - - - 'KiB  '
HND_5:
        TEST    EAX,0000FFC00H
        JZ      HND_6
        MOV     ECX,2
        MOV     EBX,5
        JMP     HND_18

; - - - End with 9 - 0 bits - - - 'Bytes'
HND_6:  ; Bytes are a special case, there is no fraction.
        MOV     BL,' '  ; Blank leading part of string.
        MOV     [HND_Str],BL
        MOV     [HND_Str+1],BL
        MOV     [HND_Str+2],BL
        MOV     EBX,0   ; Point to proper label.
        MOV     EDI,3   ; Offset for ten bit case with no fraction.

        JMP     HND_19  ; Process the 10 bit chunk.

HND_18: ; - - - Convert eighteen bits to a display string.  - - -
;        SHRD    EAX,EDX,CL      ; Oh yeah?
                                 ; turns out to not do what I wanted.
        SHR     EDX,1           ; Shift EDX:EAX CL bits to the right.
        RCR     EAX,1           ;  Inefficient, but general case.
        LOOP    HND_18
ENDIF   ; BSR and search algorithms now use the same display code.

        MOV     EDX,EAX         ; Save Int + Frac
        SHR     EDX,8           ; Discard Frac

; - - - Convert lowest eight bits to string for fraction. - - -
        MUL     [Hundred]       ; Convert binary fraction to 0 - 99
        MOV     AL,AH

IF UseAAM       ; 12 bytes (can eliminate 2 though)
        AAM                     ; Split 0 - 99 into two digits.
        ADD     AX,03030H       ; ASCIIize it
        MOV     [HND_Str+6],AH  ; And store into string.
        MOV     [HND_Str+7],AL
ELSE            ; Also 12 bytes
        XOR     AH,AH           ; AAM dosen't need this!
        DIV     BYTE PTR [Ten]  ; Split 0 - 99 into two digits.
        ADD     AX,03030H       ; ASCIIize it
        MOV     WORD PTR [HND_Str+6],AX  ; And store into string.
ENDIF
        MOV     AH,'.'
        MOV     [HND_Str+5],AH  ; And do the dot

        MOV     EAX,EDX         ; Get ten bits into (E)AX.
        MOV     EDI,0           ; Use zero offset for eighteen bit case.

HND_19: ; - - -  Convert ten bits to a display string.  - - -

;        ADD     EDI,OFFSET HND_Str ; Point to proper place to write in string.
        ADD     DI,OFFSET HND_Str ; MASM burped with 16 bit code.

; - - -  Display the lower one, two, or three digits of the number  - - -
        XOR     EDX,EDX
        DIV     [Ten]           ; Divide (E)AX by ten
        ADD     DL,030H         ; ASCIIize it
        MOV     BYTE PTR [EDI+4],DL     ; Always display 1st digit
        TEST    EAX,EAX         ; Is (E)AX empty?
        JZ      HND_20a         ; Print blanks instead of digits.

        XOR     EDX,EDX
        DIV     [Ten]           ; get next digit
        ADD     DL,030H
        MOV     BYTE PTR [EDI+3],DL
        TEST    EAX,EAX         ; Empty?
        JZ      HND_20b         ; Go print blank

        XOR     EDX,EDX
        DIV     [Ten]           ; get next digit
        ADD     DL,030H
        MOV     BYTE PTR [EDI+2],DL

; - - -  Play with possible thousands digit  - - -
        TEST    EAX,EAX ; Well, do we have it?
        JZ      HND_20c

        MOV     DX,',1'
        MOV     WORD PTR [EDI],DX
        JMP     HND_22

HND_20a:
        MOV     DL,' '  ; Second digit blank
        MOV     BYTE PTR [EDI+3],DL
HND_20b:
        MOV     DL,' '  ; Third digit blank
        MOV     BYTE PTR [EDI+2],DL
HND_20C:
        MOV     DX,'  ' ; Lead digit and comma blank
        MOV     WORD PTR [EDI],DX

HND_22: ; - - -  Label it  - - -
        MOV     EAX,DWORD PTR [EBX+Labels]
        MOV     DWORD PTR [HND_Str+9],EAX
        MOV     AL,[EBX+Labels+4]
        MOV     BYTE PTR [HND_Str+13],AL

; - - -  Restore stuff we saved, and return.  - - -

        POPFD
        POPAD
        RET

; - - -  HNumDisp ends  - - -
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
        END     Start
